您的位置:首页 > 其它

HDU 1541 Stars (树状数组 区间求和)

2016-07-28 10:03 465 查看
                                                                                                                       StarsCrawling in process...

                                                            Crawling failed
Time Limit:1000MS    
Memory Limit:32768KB     64bit IO Format:%I64d & %I64u     

Description

Input

Output

Sample Input

Sample Output

Hint

Description

Astronomers often examine star maps where stars are represented by points on a plane and each star has Cartesian coordinates. Let the level of a star be an amount of the stars that are not higher and not to the right of the given
star. Astronomers want to know the distribution of the levels of the stars.



For example, look at the map shown on the figure above. Level of the star number 5 is equal to 3 (it's formed by three stars with a numbers 1, 2 and 4). And the levels of the stars numbered by 2 and 4 are 1. At this map there are only one star of the level
0, two stars of the level 1, one star of the level 2, and one star of the level 3.

You are to write a program that will count the amounts of the stars of each level on a given map.

 

Input

The first line of the input file contains a number of stars N (1<=N<=15000). The following N lines describe coordinates of stars (two integers X and Y per line separated by a space, 0<=X,Y<=32000). There can be only one star at one
point of the plane. Stars are listed in ascending order of Y coordinate. Stars with equal Y coordinates are listed in ascending order of X coordinate.

 

Output

The output should contain N lines, one number per line. The first line contains amount of stars of the level 0, the second does amount of stars of the level 1 and so on, the last line contains amount of stars of the level N-1.

 

Sample Input

5
1 1
5 1
7 1
3 3
5 5

 

Sample Output

1
2
1
1
0 题意:给出一些星星的横坐标和纵坐标,而且星星的纵坐标递增排列,如果纵坐标相等,则横坐标按递增排列,任意两颗星星不会重合。 每个星星有个等级=左下角的星星数量分析:树状数组。星的纵坐标递增排列,如果纵坐标相等,则横坐标按递增排列 所以只利用x就可以进行计数了,如果给出一个星星的坐标为(x,y),那么它的等级就等于前面[1,x]区间内的点的个数AC 代码:
#include <iostream>
#include <cstring>
#include <algorithm>
#include <cstdio>
using namespace std;
#define N 50010
int dp
, n;
int ans
;
int lowbit(int x)
{
return x &(-x);   //二进制低位
}
void add(int x, int d)  //二进制思想
{
while (x <= N)  //注意N
{
dp[x] += d;
x += lowbit(x);  //二进制低位
}
}
int sum(int x)
{
int ret = 0;
while (x > 0)
{
ret += dp[x];
x -= lowbit(x);   //去低位求和
}
return ret;
}
int main()
{
while (scanf("%d", &n) != EOF)
{
memset(dp, 0, sizeof(dp));
memset(ans, 0, sizeof(ans));
for (int i = 1; i <= n; i++)
{
int x, y;
scanf("%d%d", &x, &y);
x++;                  //注意0时 lowbit = 0 没有低位 所以 整体后移1
ans[sum(x)]++; //记录ans
add(x, 1);
}
for (int i = 0; i < n; i++)
{
printf("%d\n", ans[i]);
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: